<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-08-14 16:51:07
 * @LastEditors  : 无尘
 * @LastEditTime : 2020-02-20 19:37:19
 -->
<!--
<contact-tree :itemData="itemData" v-model="itemData" ></contact-tree>

import contactTree from '/components/company/contact-tree.vue';
-->
<template>
  <ul class="m-l-10">
    <draggable :list="itemData" class="wx-component" :options="rightOption" @input="emitter" @change="changeData">
      <li v-for="(item, index) in itemData" :key="index + 'gic'">
        <div class="li-cell cursor-pointer" @click="toggleExpand(item)">
          <span :class="['font-12 color-606266', item.expand ? 'el-icon-caret-bottom' : 'el-icon-caret-right']"></span><span :class="['font-14 p-l-10 p-r-10 iconfont', item.isStore == 1 ? 'icondianpu-kuai' : 'iconqiye-tianchong', item.bindFlag == 1 ? 'color-2f54eb' : 'color-dedfe6']"></span><span class="font-14 color-606266">{{ item.departmentName }}</span>
        </div>
        <li-row v-if="item.expand" :itemData="item.children" @getSelectData="getSelectData"></li-row
        ><!-- v-show="!!item.children.length && item.expand" -->
      </li>
    </draggable>
  </ul>
</template>
<script>
import localforage from 'localforage';
import draggable from 'vuedraggable';
// import showMsg from '@/common/js/showmsg';
import { getRequest } from '@/api/api';
import errMsg from '@/common/js/error';
export default {
  name: 'li-row',
  components: {
    draggable
  },
  props: {
    value: {
      type: [Object, Array],
      default() {
        return [];
      }
    },
    itemData: {
      type: [Object, Array],
      default() {
        return [];
      }
    }
  },
  data() {
    return {
      rightOption: {
        group: {
          name: 'people',
          pull: true,
          put: true
        },
        sort: true
      }
    };
  },
  computed: {},
  methods: {
    /**
     *  改变数组数据
     */
    emitter(value) {
      // console.log(value);
      this.$emit('input', value);
    },
    changeData(value) {
      // console.log(value);
    },
    /**
     * 展开或者关闭下级
     */
    async toggleExpand(item) {
      const that = this;
      // console.log(item);
      item.expand = item.expand ? false : true;
      if (item.isStore == 0 && !item.children.length) {
        item.children = await that.getChildData(item);
      }
      if (item.expand) {
        localforage.setItem(item.departmentId, item);
      } else {
        localforage.removeItem(item.departmentId);
      }
      that.$emit('getSelectData', item);
      that.$forceUpdate();
    },
    /**
     * 获取选中部门/门店数据
     */
    getSelectData(obj) {
      const that = this;
      that.selectData = obj;
      that.$emit('getSelectData', obj);
    },

    /**
     * 获取下级数据
     */
    getChildData(item) {
      const that = this;
      let para = {
        parentId: item.departmentId, //
        isStore: item.isStore, //
        keyword: '' //
      };
      return new Promise((resolve, reject) => {
        getRequest('/haoban-manage3-web/department-list-level', para)
          .then(res => {
            let resData = res.data;
            if (resData.errorCode == 1) {
              if (resData.result.length) {
                resData.result.forEach(ele => {
                  ele.expand = false;
                  ele.children = [];
                  ele.label = ele.departmentName;
                });
              }
              resolve(resData.result || []);
              return false;
            }
            resolve([]);
            errMsg.errorMsg(resData);
          })
          .catch(function(error) {
            resolve([]);
            that.$message.error({
              duration: 1000,
              message: error.message
            });
          });
      });
    }
  },
  watch: {
    value: function(newData, oldData) {
      const that = this;
      that.trData = JSON.parse(JSON.stringify(newData));
    }
  },
  mounted() {
    const that = this;
    that.trData = JSON.parse(JSON.stringify(that.value));
  }
  /*  beforeDestroy() {} */
};
</script>
<style lang="less" scoped>
.li-cell {
  min-height: 26px;
  line-height: 26px;
}

.w-110 {
  width: 110px;
}

.w-320 {
  width: 320px;
}

.m-t-14 {
  margin-top: 14px;
}

.child-row {
  padding-left: 10px;
}
</style>
